package net.martinblog.amsanwang;

import java.io.ObjectOutputStream.*;
import java.util.*;

import android.app.*;
import android.content.*;
import android.os.*;
import android.view.*;
import android.widget.*;

public class AmsanwangActivity extends Activity {

	// variables for game
	int nLevel;
	int nScore;
	int nRemain;

	Handler counter;
	
	int nPreCount;
	
	Handler clock;
			
	// variables for quiz
	int nAnswer;
	int nCorrect;
	int nCount;		
	boolean bDelete;
	
	Handler quiz;
		
	ProgressBar bar;
	
	TextView myText;
	
	Button btn1;
	Button btn2;
	Button btn3;
	Button btn4;	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        myText = (TextView)findViewById(R.id.textView1);
        
        btn1 = (Button)findViewById(R.id.button1);
        btn2 = (Button)findViewById(R.id.button2);
        btn3 = (Button)findViewById(R.id.button3);
        btn4 = (Button)findViewById(R.id.button4);
        
        bar = (ProgressBar)findViewById(R.id.progressBar1);
        bar.setMax(60);
        bar.setProgress(60);
        
        btn1.setOnClickListener(mClickListener);   
        btn2.setOnClickListener(mClickListener);
        btn3.setOnClickListener(mClickListener);
        btn4.setOnClickListener(mClickListener);
        
        counter = new Handler () {
        	
        	public void handleMessage(Message msg)
        	{
        		if( !bDelete )
        		{
        			if( nPreCount > 0 )		myText.setText( String.valueOf(nPreCount) );
        			else					myText.setText( "GO!" );
	    				    				    			
	    			bDelete = true;
	    			nPreCount--;
	    			
	    			counter.sendEmptyMessageDelayed(0,  500);
        		}
        		else
        		{
        			myText.setText( "" );
        			
        			bDelete = false;        			
        		
        			if( nPreCount >= 0 )	counter.sendEmptyMessageDelayed(0,  500);
        			else					
    				{
        				clock.sendEmptyMessageDelayed(0, 1000);
        				
        				initQuiz();
    				}
        		}        		
        	}
        };
        
        clock = new Handler() {
        	
        	public void handleMessage(Message msg)
        	{
        		// display remain time at progresive bar
    			bar.setProgress(nRemain--);
    						
    			if( nRemain == -1 )	
    			{
    				// show end message
    				AlertDialog.Builder alert = new AlertDialog.Builder(AmsanwangActivity.this);
    				alert.setIcon(R.drawable.icon);
    				alert.setTitle("GAME OVER");
    				alert.setMessage(nScore + "점을 획득하였습니다.\n기록을 저장하시겠습니까?");
    				
    				alert.setPositiveButton("예", new DialogInterface.OnClickListener() {
						
						@Override
						public void onClick(DialogInterface dialog, int which) {
							
							Intent intent = new Intent(AmsanwangActivity.this, hiscore.class);
							intent.putExtra("hi-score", nScore);
							startActivity(intent);
							finish();
						}
					});
    				
					alert.setNegativeButton("아니오", new DialogInterface.OnClickListener() {
						
						@Override
						public void onClick(DialogInterface dialog, int which) {

							// re-start game
						    finish();							
						}
					});
					
					alert.show();
    				    				
    				// call high score activity
    								
    			}
    			else
    				clock.sendEmptyMessageDelayed(0, 1000);
        		
        	}
        	
        };
        
        quiz = new Handler() {
        	
        	public void handleMessage(Message msg)
        	{
        		
        		if( !bDelete )
        		{
	        		Random rand = new Random();
	    			
	    			// create quiz
	    			final int val = rand.nextInt(9) + 1;
	    			
	    			myText.setText( String.valueOf(val) );
	    			
	    			nAnswer += val;
	    			
	    			nCount++;
	    				    			
	    			bDelete = true;
	    			
	    			if( nRemain > 0 )	quiz.sendEmptyMessageDelayed(0,  500);
        		}
        		else
        		{
        			myText.setText( "" );
        			
        			bDelete = false;        			
        		
        		
	        		if( nCount == nLevel )
	    			{	
	    				// exit this quiz
	    				
	    				// call to create in-correct answer
	    				createIncorrectAnswer();
	    			}
	    			else
	    				if( nRemain > 0 )	quiz.sendEmptyMessageDelayed(0,  500);        		
        		}
        		
        	}
        };
                
	    // start game
	    initGame();	    
    }
   
    public void initGame()
    {
    	// init variables
    	nScore = 0;
    	nLevel = 2;
    	nRemain = 60;
    	
    	nPreCount = 3;
    	bDelete = false;
    	
    	// start timers
    	counter.sendEmptyMessageDelayed(0, 1000);
    }
    
    public void initQuiz()
    {
    	nAnswer = 0;
    	nCorrect = 0;
    	nCount = 0;
    	bDelete = false;
    	
    	btn1.setText("");
    	btn2.setText("");
    	btn3.setText("");
    	btn4.setText("");
    	
    	btn1.setEnabled(false);
		btn2.setEnabled(false);
		btn3.setEnabled(false);
		btn4.setEnabled(false);
    	
    	if( nRemain > 0 )	quiz.sendEmptyMessageDelayed(0,  500);
    }
            
    public void createIncorrectAnswer()
    {
    	Random rand = new Random();
    	int val = rand.nextInt(4);
    	
    	final int inc = nAnswer - val;
    	
    	nCorrect = val;
    	
    	btn1.setText( String.valueOf( inc + 0 ));
    	btn2.setText( String.valueOf( inc + 1 ));
    	btn3.setText( String.valueOf( inc + 2 ));
    	btn4.setText( String.valueOf( inc + 3 ));
    	
    	btn1.setEnabled(true);
    	btn2.setEnabled(true);
    	btn3.setEnabled(true);
    	btn4.setEnabled(true);
    	
    }
    
    Button.OnClickListener mClickListener = new View.OnClickListener() {
		
		@Override
		public void onClick(View v) {
			
			int correct = -1;
			
			switch( v.getId() ) {
			
			case R.id.button1 :				
				correct = 0;	break;
			case R.id.button2 :
				correct = 1;	break;
			case R.id.button3 :
				correct = 2;	break;
			case R.id.button4 :
				correct = 3;	break;
			}
			
			// evaluate answer
			if( nCorrect == correct )
			{
				nScore++;
				nRemain += nLevel;
			}
			else
			{
				nRemain = ( nRemain - 5 > 0 ? nRemain - 5 : nRemain );
			}
			
			// update level
			if( nScore > 14 )		nLevel = 9;
			else if( nScore > 12 )	nLevel = 8;
			else if( nScore > 10 )	nLevel = 7;
			else if( nScore > 8 )	nLevel = 6;
			else if( nScore > 6 )	nLevel = 5;
			else if( nScore > 4 )	nLevel = 4;
			else if( nScore > 2 )	nLevel = 3;
			else					nLevel = 2;
			
			TextView tv1 = (TextView)findViewById(R.id.score);
			TextView tv2 = (TextView)findViewById(R.id.level);
			tv1.setText( "Score : " + String.valueOf(nScore));
			tv2.setText( "Level : " + String.valueOf(nLevel-1));
						
			// restart quiz
			initQuiz();
		}
	}; 
	
}











