package net.martinblog.amsanwang;

import java.util.*;

import android.R.integer;
import android.app.*;
import android.content.*;
import android.os.*;
import android.view.*;
import android.widget.*;

class HighScoreList {
	
	HighScoreList( int aIcon, String aName, int aScore )
	{
		Icon = aIcon;
		Name = aName;
		Score = aScore;
	}
	
	int Icon;
	String Name;
	int Score;	
}

class HighScoreListAdapter extends BaseAdapter {
	Context maincon;
	LayoutInflater Inflater;
	ArrayList<HighScoreList> arSrc;
	int layout;
	
	public HighScoreListAdapter(Context context, int aLayout, ArrayList<HighScoreList> aarSrc)
	{
		maincon = context;
		Inflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		arSrc = aarSrc;
		layout = aLayout;
	}
	
	public int getCount() {
		return arSrc.size();
	}
	
	public String getItem(int position) {
		return arSrc.get(position).Name;
	}
	
	public long getItemId(int position) {
		return position;
	}
	
	// 각 항복의 뷰 생성
	public View getView(int position, View convertView, ViewGroup parent) {
		final int pos = position;
		if( convertView == null ) {
			convertView = Inflater.inflate(layout, parent, false);
		}
		
		ImageView img = (ImageView)convertView.findViewById(R.id.imageScore);
		img.setImageResource(arSrc.get(position).Icon);
		
		TextView name = (TextView)convertView.findViewById(R.id.textName);
		name.setText( arSrc.get(position).Name );
		
		TextView score = (TextView)convertView.findViewById(R.id.textScore);
		score.setText( String.valueOf( arSrc.get(position).Score ) );
		
		return convertView;
	}
	
}

public class hiscore extends Activity {
	
	int high = 0;
	
	ArrayList<HighScoreList>	item;
	
	List<String> name = new ArrayList<String>();
    List<Integer> score = new ArrayList<Integer>();
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.hiscore);
        
        item = new ArrayList<HighScoreList>();
        
        Intent intent = getIntent();
        high = intent.getIntExtra("hi-score", 0);
        
        final SharedPreferences pref = getSharedPreferences("highscore", 0);
        final SharedPreferences.Editor edit = pref.edit();
        
        int i;
        
        // get high-score data
        for( i=0;i<5;i++ )
        {	
        	name.add( pref.getString("name" + String.valueOf(i), "") );
        	score.add( pref.getInt("score" + String.valueOf(i), 0) );
        }
        
        DisplayHiscore();
                
        if( high > 0 )
        {               
	        // Input Name
	        final LinearLayout layout = (LinearLayout)View.inflate(hiscore.this, R.layout.name, null);
	        
	        new AlertDialog.Builder(hiscore.this)
	        .setTitle("이름을 입력하세요.")
	        .setIcon(R.drawable.icon)
	        .setView(layout)	        
	        .setPositiveButton("확인", new DialogInterface.OnClickListener() {
				
				@Override
				public void onClick(DialogInterface dialog, int which) {
					
					EditText edName = (EditText)layout.findViewById(R.id.nameBox);
					
					// add new score info.
					for( int i=0;i<5;i++ )
			        {
						if( score.get(i) < high )
						{	
							score.add( i, high );
							name.add( i, edName.getText().toString() );
							break;
						}
			        }
					
					for( int i=0;i<5;i++ )
			        {
						edit.putString("name" + String.valueOf(i), name.get(i));
						edit.putInt("score" + String.valueOf(i), score.get(i));
			        }
					
					edit.commit();
					
					DisplayHiscore();
				}
			}).show();
        }        
        
        Button btn = (Button)findViewById(R.id.clear);
        btn.setOnClickListener( new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				score.clear();
				name.clear();
				
				for( int i=0;i<5;i++ )
				{
					// save
					edit.putString("name" + String.valueOf(i), "");
					edit.putInt("score" + String.valueOf(i), 0);
					
					score.add( i, 0 );
					name.add( i, "" );
				}
				
				edit.commit();
				
				DisplayHiscore();
			}
		});
    }
    
    private void DisplayHiscore() {
		
    	item.clear();
    			
		// show/save high-score info.		
		HighScoreList mi;
		
		int iIcon = 0;
		
		for( int i=0;i<5;i++ )
		{
			// show
			switch (i)
			{
			case 0:	iIcon = R.drawable.king;			break;
			case 1:	iIcon = R.drawable.queen;			break;
			case 2:	iIcon = R.drawable.medal_gold;		break;
			case 3:	iIcon = R.drawable.medal_silver;	break;
			case 4:	iIcon = R.drawable.medal_bronze;	break;
			}
			
			mi = new HighScoreList(iIcon, name.get(i), score.get(i));	
			item.add(mi);												
		}
		
		HighScoreListAdapter adapter = new HighScoreListAdapter(hiscore.this, R.layout.score, item);
		
		ListView list;
		list = (ListView)findViewById(R.id.rank);
		list.setAdapter(adapter);
	}
}
